MANIFEST $(   // AE operators and symbols
S.NUMBER=1; S.NAME=2; S.STRING=3; S.TRUE=4; S.FALSE=5
S.VALOF=6; S.LV=7; S.RV=8; S.VECAP=9; S.FNAP=10
S.MULT=11; S.DIV=12; S.REM=13
S.PLUS=14; S.MINUS=15; S.NEG=17
S.FIX=18; S.ABS=19
S.EQ=20; S.NE=21; S.LS=22; S.GR=23; S.LE=24; S.GE=25
S.SLCT=26; S.SLCTAP=27; S.BYTEAP=28
S.NOT=30; S.LSHIFT=31; S.RSHIFT=32; S.LOGAND=33; S.LOGOR=34
S.EQV=35; S.NEQV=36; S.COND=37; S.COMMA=38; S.TABLE=39

S.AND=40; S.VALDEF=41; S.VECDEF=42; S.CONSTDEF=43
S.FNDEF=44; S.RTDEF=45

S.NEEDS=48;S.SECTION=49
S.ASS=50; S.RTAP=51; S.GOTO=52; S.RESULTIS=53
S.COLON=54
S.TEST=55; S.FOR=56; S.IF=57; S.UNLESS=58
S.WHILE=59; S.UNTIL=60; S.REPEAT=61; S.REPEATWHILE=62
S.REPEATUNTIL=63; S.LOOP=65; S.BREAK=66; S.RETURN=67; S.FINISH=68
S.ENDCASE=69; S.SWITCHON=70; S.CASE=71; S.DEFAULT=72
S.SEQ=73; S.LET=74; S.MANIFEST=75; S.GLOBAL=76; S.STATIC=79

S.QUERY=80; S.CONT=81

    // floating point AE operators

S.FMULT=267; S.FDIV=268;
S.FPLUS=270; S.FMINUS=271; S.FNEG=273
S.FLOAT=274; S.FABS=275
S.FEQ=276; S.FNE=277; S.FLS=278; S.FGR=279; S.FLE=280; S.FGE=281

FLBIT=256; BECOMESBIT=512
$)

MANIFEST $(   // other canonical symbols
S.BE=89; S.END=90; S.LSECT=91; S.RSECT=92; S.GET=93
S.SEMICOLON=97; S.INTO=98; S.TO=99; S.BY=100; S.DO=101; S.OR=102
S.VEC=103; S.LPAREN=105; S.RPAREN=106
$)

GLOBAL $( SYSOPT:320; OCODESTREAM:324; SOURCESTREAM:325
          DIAGNOSTICS:326
          CHARCODE:330; REPORTCOUNT:331; REPORTMAX:332
          FORCEUPPERCASE:333; UPPERCASE:335
          SECTIONNAME:336; UPPERCASESTRING:337
$)

GLOBAL $(    // globals used in pp
CHBUF:102; DECVAL:101
GETV:103; GETP:104; GETT:105
WORDV:106; WORDSIZE:107; CHARV:108; CHARP:109
PRSOURCE:110; PRLINE:111; SYMB:115; WORDNODE:116; CH:117; RDTAG:118
NEXTSYMB:120; DECLSYSWORDS:121; NLPENDING:122
LOOKUPWORD:125; RCH:126; PPTRACE:127; NOGET:128; QUIET:129
LEXTEST:130
WRCHBUF:131; CHCOUNT:132; LINECOUNT:133
NULLTAG:134; REC.P:135; REC.L:136
READFLOAT:137; READNUMBER:138
$)

GLOBAL $(   // globals used in CAE
RDBLOCKBODY:140;  RDSECT:141
RNAMELIST:142; RNAME:143
REXP:144; RDEF:145; RCOM:146
RDCDEFS:147; NAMETABLE:148; NAMETABLESIZE:149
FORMTREE:150; CAEREPORT:151; PLIST:152
CHECKFOR:153; IGNORE:154; PERFORMGET:155; REXPLIST:156
NAMESECTION:157
LIST1:161; LIST2:162; LIST3:163; LIST4:164; LIST5:165
NEWVEC:166; LIST6:169
RBEXP:174
$)

GLOBAL $(      // globals used for storage management
WORKBASE:350; WORKTOP:351; TREEP:352
$)

MANIFEST $(    //  selectors
H1=0; H2=1; H3=2; H4=3; H5=4; H6=5
$)
