// This is an OCODE to Intcode codegenerator dated 1982 approx

//    CG-int


GET "LIBHDR"

// OCODE OPERATORS

MANIFEST
$(    s_true          =    4
      s_false         =    5
      s_rv            =    8
      s_fnap          =   10
      s_mult          =   11
      s_div           =   12
      s_rem           =   13
      s_plus          =   14
      s_minus         =   15
      s_query         =   16
      s_neg           =   17
      s_abs           =   19
      s_eq            =   20
      s_ne            =   21
      s_ls            =   22
      s_gr            =   23
      s_le            =   24
      s_ge            =   25
      s_not           =   30
      s_lshift        =   31
      s_rshift        =   32
      s_logand        =   33
      s_logor         =   34
      s_eqv           =   35
      s_neqv          =   36
      s_cond          =   37
      s_lp            =   40
      s_lg            =   41
      s_ln            =   42
      s_lstr          =   43
      s_ll            =   44
      s_llp           =   45
      s_llg           =   46
      s_lll           =   47
      s_needs         =   48
      s_section       =   49
      s_rtap          =   51
      s_goto          =   52
      s_for           =   56
      s_return        =   67
      s_finish        =   68
      s_switchon      =   70
      s_global        =   76
      s_sp            =   80
      s_sg            =   81
      s_sl            =   82
      s_stind         =   83
      s_jump          =   85
      s_jt            =   86
      s_jf            =   87
      s_endfor        =   88
      s_lab           =   90
      s_stack         =   91
      s_store         =   92
      s_rstack        =   93
      s_entry         =   94
      s_save          =   95
      s_fnrn          =   96
      s_rtrn          =   97
      s_res           =   98
      s_reslab        =   99
      s_datalab       =  100
      s_iteml         =  101
      s_itemn         =  102
      s_endproc       =  103
      s_end           =  104
      s_char          =  105
      error           =  108
      s_debug         =  109
      s_startblock    =  110
      s_none          =  111
      s_mod           =  116
      s_getbyte       =  120
      s_putbyte       =  121
$)




// Code Generator Globals:

GLOBAL
$(  rc:                  150
    fromfile:            151
    verstream:           152
    ocodestream:         153
    codestream:          154
    datvec:              155
    err.p:               156
    err.l:               157
    ocodefile:           158
    keepocode:           159

    // CG options

    cgworksize:          160
    cglisting:           161
    naming:              162
    callcounting:        163
    profcounting:        164
    stkchking:           165
    restricted:          166
    altobj:              167
    cg.a:                168
    cg.b:                169
    cg.y:                175
    cg.z:                176
$)



MANIFEST
$(  free.global = 177
$)




GLOBAL
$(  ch:         free.global+0
    wordv:      free.global+1
    sysprint:   free.global+3
    sysin:      free.global+4
    ssp:        free.global+5
    state:      free.global+6
    ad_a:       free.global+7
    ad_k:       free.global+8
    option:     free.global+9
    datav:      free.global+10
    datap:      free.global+11
    datat:      free.global+12
    proglength: free.global+13
    linep:      free.global+14
    param:      free.global+15
    op:         free.global+16
    readop:     free.global+17
    rdn:        free.global+18
    rdl:        free.global+19
    gencode:    free.global+20
    force.nil:  free.global+21
    force.ad:   free.global+22
    force.ac:   free.global+23
    force.acad: free.global+24
    swap:       free.global+25
    load:       free.global+26
    storein:    free.global+27
    cgstring:   free.global+28
    data:       free.global+29
    nextparam:  free.global+30
    code:       free.global+31
    complab:    free.global+32
    opcode:     free.global+33
    wr:         free.global+34
    wrn:        free.global+35
    wrdata:     free.global+36
$)

MANIFEST $(
    m_n           = 0
    m_i           = 1
    m_p           = 2
    m_ip          = 3
    m_l           = 4
    m_il          = 5
    m_g           = 6
    m_ig          = 7
    f_l           = 'L'
    f_s           = 'S'
    f_a           = 'A'
    f_j           = 'J'
    f_t           = 'T'
    f_f           = 'F'
    f_k           = 'K'
    f_x           = 'X'
    f_d           = 'D'
    f_c           = 'C'
    nil           = 0
    ad            = 1
    ac            = 2
    acad          = 3
$)



