// $Id: LIBHDR,v 1.7 2013/01/29 17:31:40 rn Exp $

//  libhdr
GLOBAL $(
START		: 1
SYS			: 2
ABORT		: 3					// Calls BACKTRACE and MAPSTORE
BACKTRACE	: 4
STACKTRACE	: 4					// Summarise the run-time stack
TRAP		: 5

SELECTINPUT	: 11
SELECTOUTPUT	: 12
RDCH		: 13
WRCH		: 14
UNRDCH		: 15
INPUT		: 16
OUTPUT		: 17

TIMEOFDAY	: 27
TIME		: 28
DATE		: 29
STOP		: 30
LEVEL		: 31
LONGJUMP	: 32
REWIND		: 35

APTOVEC		: 40
FINDOUTPUT	: 41
FINDINPUT	: 42
FINDAPPEND	: 43
ENDSTREAM	: 45
ENDREAD		: 46
ENDWRITE	: 47
FILETABLE	: 48							// for diagnostics: 24-Oct-2012
RENAME		: 49
DELETE		: 50
ENDTOINPUT	: 51
GETENV		: 52
PATHFINDINPUT	: 53
FINDFILE	: 54
FSEEK		: 55

WRITES		: 60
WRITEN		: 62
NEWLINE		: 63
NEWPAGE		: 64
PACKSTRING	: 66
UNPACKSTRING	: 67
WRITED		: 68
READN		: 70
TERMINATOR	: 71

CAPITALCH	: 74
WRITEHEX	: 75
WRITEF		: 76
WRITEOCT	: 77
MAPSTORE	: 78

GETBYTE		: 85
PUTBYTE		: 86
GETVEC		: 87
FREEVEC		: 88

RDARGS		: 90
RESULT2		: 91
STRCAT		: 92
STR2NO		: 93
STR2NUMB	: 94
STACKBASE	: 95
STACKEND	: 96
ARGC		: 97
ARGV		: 98
PARAM		: 99

start		: 1
sys			: 2
abort		: 3					// Calls BACKTRACE and MAPSTORE
backtrace	: 4
stacktrace	: 4					// Summarise the run-time stack
trap		: 5

selectinput	: 11
selectoutput	: 12
rdch		: 13
wrch		: 14
unrdch		: 15
input		: 16
output		: 17

timeofday	: 27
time		: 28
date		: 29
stop		: 30
level		: 31
longjump	: 32
rewind		: 35

aptovec		: 40
findoutput	: 41
findinput	: 42
findappend	: 43
endstream	: 45
endread		: 46
endwrite	: 47
filetable	: 48							// for diagnostics: 24-oct-2012
rename		: 49
delete		: 50
endtoinput	: 51
getenv		: 52
pathfindinput	: 53
findfile	: 54
fseek		: 55

writes		: 60
writen		: 62
newline		: 63
newpage		: 64
packstring	: 66
unpackstring	: 67
writed		: 68
readn		: 70
terminator	: 71

capitalch	: 74
writehex	: 75
writef		: 76
writeoct	: 77
mapstore	: 78

getbyte		: 85
putbyte		: 86
getvec		: 87
freevec		: 88

rdargs		: 90
result2		: 91
strcat		: 92
str2no		: 93
str2numb	: 94
stackbase	: 95
stackend	: 96
argc		: 97
argv		: 98
param		: 99
$)


MANIFEST $(
SYSIN		= 0
SYSOUT		= 1
SYSERR		= 2				// Standard input, output and error streams (preopened, set to console)

ENDSTREAMCH	= -1
BYTESPERWORD= 4
BITSPERWORD	= 32
MAXSTRLENGTH= 255
MAXINT		= #X7FFFFFFF
MININT		= #X80000000
FIRSTFREEGLOBAL	= 100
UG = FIRSTFREEGLOBAL

sysin		= 0
sysout		= 1
syserr		= 2				// Standard input, output and error streams (preopened, set to console)

endstreamch	= -1
bytesperword= 4
bitsperword	= 32
maxstrlength= 255
maxint		= #X7FFFFFFF
minint		= #X80000000
firstfreeglobal	= 100
ug = firstfreeglobal
$)
