// Copyright (c) 2021 Dave Cannon

// BCPL compiler x86 runtime

// This file associates EXTERNAL names with entries in the global vector; change in line with 'libhdr.h'

	.data
	.global G

	.global	start
	.global	sys
	.global	abort
	.global	backtrace
	.global	stacktrace
	.global	trap

	.global	selectinput
	.global	selectoutput
	.global	rdch
	.global	wrch
	.global	unrdch
	.global	input
	.global	output

	.global	timeofday
	.global	time
	.global	date
	.global	stop
	.global	level
	.global	longjump
	.global	rewind

	.global	aptovec
	.global	findoutput
	.global	findinput
	.global	findappend
	.global	endstream
	.global	endread
	.global	endwrite
	.global	filetable
	.global	rename
	.global	delete
	.global	endtoinput
	.global	getenv
	.global	pathfindinput
	.global	findfile
	.global	fseek

	.global	writes
	.global	writen
	.global	newline
	.global	newpage
	.global	packstring
	.global	unpackstring
	.global	writed
	.global	readn
	.global	terminator

	.global	capitalch
	.global	writehex
	.global	writef
	.global	writeoct
	.global	mapstore
	.global	swritef

	.global	getbyte
	.global	putbyte
	.global	getvec
	.global	freevec

	.global	rdargs
	.global	result2
	.global	strcat
	.global	str2no
	.global	str2numb
	.global	stackbase
	.global	stackend
	.global	argc
	.global	argv
	.global	param


	.equ	start,		G+1*4
	.equ	sys,		G+2*4
	.equ	abort,		G+3*4
	.equ	backtrace,	G+4*4
	.equ	stacktrace,	G+4*4
	.equ	trap,		G+5*4

	.equ	selectinput	,	G+11*4
	.equ	selectoutput,	G+12*4
	.equ	rdch,		G+13*4
	.equ	wrch,		G+14*4
	.equ	unrdch,		G+15*4
	.equ	input,		G+16*4
	.equ	output,		G+17*4

	.equ	timeofday,	G+27*4
	.equ	time,		G+28*4
	.equ	date,		G+29*4
	.equ	stop,		G+30*4
	.equ	level,		G+31*4
	.equ	longjump,	G+32*4
	.equ	rewind,		G+35*4

	.equ	aptovec,	G+40*4
	.equ	findoutput,	G+41*4
	.equ	findinput,	G+42*4
	.equ	findappend,	G+43*4
	.equ	endstream,	G+45*4
	.equ	endread,	G+46*4
	.equ	endwrite,	G+47*4
	.equ	filetable,	G+48*4
	.equ	rename,		G+49*4
	.equ	delete,		G+50*4
	.equ	endtoinput,	G+51*4
	.equ	getenv,		G+52*4
	.equ	pathfindinput,	G+53*4
	.equ	findfile,	G+54*4
	.equ	fseek,		G+55*4

	.equ	writes,		G+60*4
	.equ	writen,		G+62*4
	.equ	newline	,	G+63*4
	.equ	newpage,	G+64*4
	.equ	packstring,	G+66*4
	.equ	unpackstring,	G+67*4
	.equ	writed,		G+68*4
	.equ	readn,		G+70*4
	.equ	terminator,	G+71*4

	.equ	capitalch,	G+74*4
	.equ	writehex,	G+75*4
	.equ	writef,		G+76*4
	.equ	writeoct,	G+77*4
	.equ	mapstore,	G+78*4
	.equ	swritef,	G+79*4

	.equ	getbyte,	G+85*4
	.equ	putbyte,	G+86*4
	.equ	getvec,		G+87*4
	.equ	freevec,	G+88*4

	.equ	rdargs,		G+90*4
	.equ	result2,	G+91*4
	.equ	strcat,		G+92*4
	.equ	str2no,		G+93*4
	.equ	str2numb,	G+94*4
	.equ	stackbase,	G+95*4
	.equ	stackend,	G+96*4
	.equ	argc,		G+97*4
	.equ	argv,		G+98*4
	.equ	param,		G+99*4

