//   CGHDR

MANIFEST {
// Object module item types.
t_hunk  = 2000       // hunk   n  w1 ... wn
t_reloc = 2001       // reloc  n  a1 ... an
t_end   = 2002       // end

modword   = #xFDDF   // MODULE and Entry marker words.
entryword = #xDFDF

               // MCODE operators
s_ln=1
s_true=5
s_false=6
s_query=7

s_lp=10
s_lg=11

s_llp=13
s_llg=14

s_sp=16
s_sg=17
s_lf=18
s_lx=19

s_neg=21
s_abs=22
s_not=23
s_bitnot=24

s_callc=29
s_call=30
s_indw=31
s_indw0=32
s_indb=33
s_indb0=34
s_lsh=35  // same order as op:= operators
s_rsh=36
s_mult=37
s_div=38
s_mod=39
s_bitand=40
s_xor=41
s_plus=42
s_sub=43
s_bitor=44

s_eq=45
s_ne=46
s_le=47
s_ge=48
s_ls=49
s_gr=50
s_rel=51

s_ptr=59
s_ll=60
s_lll=61
s_sl=62
s_lpath=63
s_llpath=64
s_spath=65
s_stw=66
s_stb=67
s_lvindw=68
s_cpr=69

s_jt=70
s_jf=71
s_lab=72
s_stack=73

s_dup=79
s_lr=80
s_str=81
s_jump=82
s_dlab=83
s_dw=84
s_db=85
s_dl=86
s_ds=87

s_inc1b=90
s_inc4b=91
s_dec1b=92
s_dec4b=93
s_inc1a=94
s_inc4a=95
s_dec1a=96
s_dec4a=97

s_goto=103
s_raise=104
s_handle=105

s_match=120
s_return=124

s_module=145
s_endmodule=146

s_global=150
s_fun=151
s_cfun=152
s_endfun=153
s_unhandle=156
s_line=157
s_file=158
s_setargs=159
s_fnargs=160
s_locs=161

s_none=200

             //  Selectors
h1=0; h2=1; h3=2; h4=3

savespacesize=2						// ...was 3, for Cintcode version	DC: 27-Aug-2015


hashtabsize=63
}

GLOBAL {
cgmodules   : 401
rdn         : 402
rdl         : 403
rdgn        : 404
rdstr       : 405
newlab      : 406
checklab    : 407
cgerror     : 408

initstack   : 410
stack       : 411
store       : 412
scan        : 413
cgpendingop : 414

loadba      : 416
setba       : 417

genxch      : 420
genatb      : 421

loada       : 422
push        : 423
loadboth    : 424
inreg_a     : 425
inreg_b     : 426
addinfo_a   : 427
addinfo_b   : 428
pushinfo    : 429
xchinfo     : 430
atbinfo     : 431
btainfo     : 432

forget_a    : 435
forget_b    : 436
forgetall   : 437
forgetvar   : 438
forgetallvars: 439

iszero      : 440
storet      : 441
storeshared : 442

loadt       : 443
lose1       : 444
swapargs    : 445
cgstw       : 446
storein     : 447
cgindw0     : 448

cginc       : 449
cgplus      : 450
cgaddk      : 451
cgglobal    : 452
cgentry     : 453
cgcall      : 455
cgjump      : 457

jmpfn       : 458
jfn0        : 459
revjfn      : 460
compjfn     : 461
prepj       : 462
cgraise     : 463

cgstatics   : 477
getblk      : 478
freeblk     : 479
freeblks    : 480

initdatalists : 481

genfp       : 500
genfkp      : 501
genfkp      : 502
genfg       : 503
genfkg      : 504
genfpg      : 505
genfk       : 506
genfw       : 507
genfl       : 508
genflk      : 509
genfkl      : 510
genfm       : 511
genfmw      : 512

genf        : 520
geng        : 521
genc        : 522
genk        : 523
genw        : 524
genl        : 525

cgrelop     : 530

checkspace  : 531

dboutput    : 540
wrkn        : 541
wrcode      : 542

// Global variables.
procdepth   : 550

ssp         : 551
tempt       : 552
tempv       : 553

arg1        : 554
arg2        : 555
debug       : 556
bigender    : 557

ch          : 560
op          : 561
pendingop   : 562
mlabnumber  : 563
incode      : 565

lineno      : 570
progsize    : 571
maxgn       : 572
maxssp      : 573

info_a      : 575
info_b      : 576

clist       : 580
cliste      : 581

dpbase      : 590
dp          : 591
freelist    : 592

hashtab     : 595
charv       : 596
lookup      : 597
newvec      : 598
}

GLOBAL {
//General Interface
errcount:600; errmax:601; fin_p:602; fin_l:603
sourcestream:604; sysprint:605; mcodeout:606
treep:607; treevec:608; findfilename:609

//Syn interface
chbuf:610; ch:611; chcount:612; lineno:613
rch:614; findfileno:615; filelist:616; freefilelist:617
formtree:618; plist:619

// Trn interface
translate:620

// Cg interface
mcodein:630; tostream: 631
codegenerate: 632
wrarg: 633; codelayout:634
}


MANIFEST
{
// Value descriptors.
k_none=0
k_numb=1   // numbers in the range -#xFFFFFF to #xFFFFFF
k_lw=2     // label addressing larger constants
k_fnlab=3
k_lvloc=4; k_lvglob=5; k_lvlab=6;
k_a=8; k_b=9; k_c=10

k_ext=11
k_loc=12; k_glob=13; k_lab=14;

k_loci=15;  k_lvloci=16    //  <27-bits> loci    ie P!<27-bits>!n
k_globi=17; k_lvglobi=18   //  <27-bits> globi   ie G!<27-bits>!n
k_labi=19;  k_lvlabi=20    //  <27-bits> labi    ie L<27-bits>!n

swapped=TRUE; notswapped=FALSE
}

MANIFEST {
// MIAL op codes and directives

f_lp=      1
f_lg=      2
f_ll=      3

f_llp=     4
f_llg=     5
f_lll=     6
f_lf=      7
f_lw=      8

f_l=      10
f_lm=     11

f_sp=     12
f_sg=     13
f_sl=     14

f_ap=     15
f_ag=     16
f_a=      17
f_s=      18

f_lkp=    20
f_lkg=    21
f_rv=     22
f_rvp=    23
f_rvk=    24
f_st=     25
f_stp=    26
f_stk=    27
f_stkp=   28
f_stkg=   29
f_xst=    30

f_stb=    31
f_lvind=  32
f_indb=   33
f_indb0=  34
f_indw=   35

f_k=      36
f_kpg=    37

f_neg=    38
f_not=    39
f_abs=    40

f_xdiv=   41
f_xmod=   42
f_xsub=   43

f_mul=    45
f_div=    46
f_mod=    47
f_add=    48
f_sub=    49

f_eq=     50
f_ne=     51
f_ls=     52
f_gr=     53
f_le=     54
f_ge=     55
f_eq0=    56
f_ne0=    57
f_ls0=    58
f_gr0=    59
f_le0=    60
f_ge0=    61

f_lsh=    65
f_rsh=    66
f_and=    67
f_or=     68
f_xor=    69
f_lshk=   70
f_rshk=   71

f_xch=    80
f_atb=    81
f_atc=    82
f_bta=    83
f_btc=    84
f_cta=    85
f_atblp=  86
f_atblg=  87
f_atbll=  88
f_atbl=   89

f_j=      90
f_rtn=    91

f_ikp=    93
f_ikg=    94
f_ikl=    95
f_ip=     96
f_ig=     97
f_il=     98

f_jeq=    100
f_jne=    101
f_jls=    102
f_jgr=    103
f_jle=    104
f_jge=    105
f_jeq0=   106
f_jne0=   107
f_jls0=   108
f_jgr0=   109
f_jle0=   110
f_jge0=   111

f_brk=    120
f_nop=    121
f_chgco=  122
f_mdiv=   123
f_sys=    124

f_inc1b=  130
f_inc4b=  131
f_dec1b=  132
f_dec4b=  133
f_inc1a=  134
f_inc4a=  135
f_dec1a=  136
f_dec4a=  137

f_hand =  140
f_unh  =  141
f_raise=  142

f_module=   150
f_modstart= 151
f_modend=   152
f_global=   153

f_const=    155

f_lab=      157
f_entry=    158

f_dlab=     160
f_dw=       161
f_db=       162
f_dl=       163
f_ds=       164
}

